(*****************************************}
{*	Platform sprite, moveable version, not faceless		*}
{/****************************************)

unit sHMovPlatform;
interface
	uses
{$ifc UNDEFINED THINK_PASCAL}
		Types, QuickDraw, Menus, Windows, TextEdit, Fonts, Dialogs, Memory, {}
{$endc}
		SAT, PlatformGlobals, sPlayerSprite;

	procedure InitHMovPlatform;
	procedure SetupHMovPlatform (me: SpritePtr);

implementation

	const
		MovPlatformSpeed = 2;

	var
		platFace: FacePtr;

	procedure InitHMovPlatform;
	begin
		platFace := SATGetFace(139);
	end;

	procedure HandleHMovPlatform (me: SpritePtr);
	begin
		me^.position.h := me^.position.h + me^.speed.h;
		if (me^.position.h < MovPlatP(me^.appPtr)^.MinV) then
			me^.speed.h := MovPlatformSpeed;
		if (me^.position.h > MovPlatP(me^.appPtr)^.MaxV) then
			me^.speed.h := -MovPlatformSpeed;

		if (me^.speed.h = 0) then
			begin
				if (me^.position.h > (MovPlatP(me^.appPtr)^.MaxV - MovPlatP(me^.appPtr)^.MinV) div 2) then
					me^.speed.h := -MovPlatformSpeed
				else
					me^.speed.h := MovPlatformSpeed;
			end;

		me^.layer := -me^.position.v;
	end;

	procedure HitHMovPlatform (me: SpritePtr; him: PlSpritePtr);
		var
			mini, i, min: Integer;
			diff: array[0..5] of Integer;
	begin
		if (him^.task = @HandlePlayerSprite) then
			begin
				diff[1] := -me^.hotRect2.top + (him^.hotRect2.bottom);		(* (T)toB *)
				diff[2] := -him^.hotRect2.top + (me^.hotRect2.bottom);		(* (B)toT *)
				diff[3] := -me^.hotRect2.left + (him^.hotRect2.right);			(* LtoR *)
				diff[4] := -him^.hotRect2.left + (me^.hotRect2.right);			(* RtoL *)
				mini := 0;
				min := 10000;
				for i := 1 to 4 do
					if min > diff[i] then
						begin
							min := diff[i];
							mini := i;
						end;
				case mini of
					1: (*floor*)
						begin
							him^.action := StandOnHMovPlatform;
							him^.speed.h := me^.speed.h;
							him^.position.v := him^.position.v - diff[1] + 1;
							him^.position.h := him^.position.h + me^.speed.h;
							if him^.speed.v > 0 then
								him^.speed.h := 0;
						end;
					2: (* ceiling *)
						begin
							him^.position.v := him^.position.v + diff[2] + 1;
							if (him^.speed.v < 0) then
								him^.speed.v := -him^.speed.v;
						end;
					3: (*left*)
						begin
							him^.position.h := him^.position.h - diff[3] - 1;
							if him^.speed.h > 0 then
								him^.speed.h := -him^.speed.h;
						end;
					4: (*right*)
						begin
							him^.position.h := him^.position.h + diff[4] + 1;
							if him^.speed.h < 0 then
								him^.speed.h := -him^.speed.h;
						end;
				end; (* switch *)
			end;  (* if *)
	end;

	procedure SetupHMovPlatform (me: SpritePtr);
		var
			r: Rect;
			pol: PolyHandle;
	begin
		me^.speed.h := -1 + SATRand(2) * 2;
		me^.face := platFace;
		me^.appPtr := NewPtr(sizeof(MovPlatRec));
		if me^.appPtr <> nil then
			begin
				MovPlatP(me^.appPtr)^.MaxV := me^.position.h;
				MovPlatP(me^.appPtr)^.MinV := me^.kind;
			end;
		SetRect(me^.hotRect, 0, 3, 60, 20);
		me^.task := @HandleHMovPlatform;
		me^.hitTask := @HitHMovPlatform;
	end;

end.